﻿namespace Guia.Elements
{
    using System.Windows.Automation;
    using Guia.Locator;

    /// <summary>
    /// This class represents a particular row within a DataGrid_ListView.
    /// </summary>
    public class DataGridRow_ListView : AbstractDataGridRow
    {
        /// <summary>
        /// Initializes a new instance of the DataGridRow_ListView class. 
        /// </summary>
        /// <param name="automationElement">The AutomationElement representating the DataGridRow.</param>
        public DataGridRow_ListView(AutomationElement automationElement)
            : base(automationElement)
        {
        }

        /// <summary>
        /// Gets the default-condition to find a control by its type.
        /// </summary>
        public static SearchCondition ControlTypeCondition
        {
            get { return SearchCondition.ByControlType(ControlType.DataItem); }
        }

        /// <summary>
        /// Gets a list of the row's cells. 
        /// </summary>
        public DataGridCell_ListView[] Cells
        {
            get
            {
                return this.GetCells<DataGridCell_ListView>();
            }
        }
    }
}
