namespace Guia.Config
{
    /// <summary>
    /// Interface for the configuration
    /// </summary>
    public interface IConfig
    {
        /// <summary>
        /// Gets the timeout for the element search
        /// </summary>
        int ElementTimeout
        { 
            get;
        }

        /// <summary>
        /// Gets the timeout for the window search
        /// </summary>
        int WindowTimeout
        { 
            get;
        }

        /// <summary>
        /// Gets the timeout for the closing of modal windows.
        /// </summary>
        int CloseModalWindowsTimeout
        { 
            get;
        }

        /// <summary>
        /// Gets the localized name of an element
        /// </summary>
        /// <param name="element">The element wanted</param>
        /// <returns>The localized name of the given element</returns>
        string GetLocalizedName(EElementIdentifier element);
    }
}