namespace Guia.Elements
{
    using System.Windows.Automation;
    using Locator;

    /// <summary>
    /// This class represents a Menu.
    /// </summary>
    public class Menu : AbstractMenuItem
    {
        /// <summary>
        /// Initializes a new instance of the Menu class. 
        /// </summary>
        /// <param name="automationElement">The AutomationElement representating the Menu.</param>
        public Menu(AutomationElement automationElement)
            : base(automationElement)
        {
        }

        /// <summary>
        /// Gets the default-condition to find a control by its type.
        /// </summary>
        public static SearchCondition ControlTypeCondition
        {
            get { return SearchCondition.ByControlType(ControlType.Menu); }
        }
    }
}