﻿namespace Guia.Elements.PatternServants
{
    /// <summary>
    /// Represents the interface for the ExpandCollapse-Pattern.
    /// </summary>
    public interface IExpandCollapse
    {
        /// <summary>
        /// Gets or sets a value indicating whether the state of this UiElement is expanded or not.
        /// </summary>
        bool IsExpanded { get; set; }

        /// <summary>
        /// Expands the UiElement
        /// </summary>
        void Expand();

        /// <summary>
        /// Collapses the UiElement
        /// </summary>
        void Collapse();
    }
}
