﻿namespace Guia.Elements.PatternServants
{
    /// <summary>
    /// Represents the interface for the GridItem-Pattern.
    /// </summary>
    public interface IGridItem
    {
        /// <summary>
        /// Gets the number of the grid-item's row.
        /// </summary>
        int Row { get; }
        
        /// <summary>
        /// Gets the number of the grid-item's column.
        /// </summary>
        int Column { get; }

        /// <summary>
        /// Gets the grid-item's row-span.
        /// </summary>
        int RowSpan { get; }

        /// <summary>
        /// Gets the grid-item's column-span.
        /// </summary>
        int ColumnSpan { get; }
    }
}
