﻿namespace Guia.Elements.PatternServants
{
    using System;

    /// <summary>
    /// Represents the interface for the SelectionItem-Pattern for multiple-selection.
    /// </summary>
    public interface ISelectionItemMulti : ISelectionItemSingle
    {
        /// <summary>
        /// Adds this item to the selection of its parent.
        /// </summary>
        /// <exception cref="InvalidOperationException">An InvalidOperationException is thrown, when this addition to the selection is not supported (e.g. because multi-select is not supported).</exception>
        void AddToSelection();
    }
}